Index: cpukit/rtems/src/taskmp.c
===================================================================
--- cpukit/rtems/src/taskmp.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/rtems/src/taskmp.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,84 +1,28 @@
-/* SPDX-License-Identifier: BSD-2-Clause */
-
-/**
- * @file
- *
- * @ingroup RTEMSImplClassicTaskMP
- *
- * @brief This source file contains the implementation to support the Task
- *   Manager in multiprocessing (MP) configurations.
- */
-
 /*
- *  COPYRIGHT (c) 1989-2008.
+ *  Multiprocessing Support for the RTEMS Task Manager
+ *
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
  *  On-Line Applications Research Corporation (OAR).
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
-
-#include <rtems/rtems/tasksimpl.h>
-#include <rtems/rtems/optionsimpl.h>
-#include <rtems/rtems/statusimpl.h>
-#include <rtems/score/statesimpl.h>
-#include <rtems/score/threadimpl.h>
-#include <rtems/score/threadqimpl.h>
-#include <rtems/sysinit.h>
-
-/**
- *  The following data structure defines the packet used to perform
- *  remote task operations.
- */
-typedef struct {
-  rtems_packet_prefix               Prefix;
-  RTEMS_tasks_MP_Remote_operations  operation;
-  rtems_name                        name;
-  rtems_task_priority               the_priority;
-}   RTEMS_tasks_MP_Packet;
-
-RTEMS_STATIC_ASSERT(
-  sizeof(RTEMS_tasks_MP_Packet) <= MP_PACKET_MINIMUM_PACKET_SIZE,
-  RTEMS_tasks_MP_Packet
-);
-
-static RTEMS_tasks_MP_Packet *_RTEMS_tasks_MP_Get_packet( void )
-{
-  return (RTEMS_tasks_MP_Packet *) _MPCI_Get_packet();
-}
-
-static RTEMS_tasks_MP_Packet *_RTEMS_tasks_MP_Get_request_packet(
-  Objects_Id id
-)
-{
-  if ( !_Thread_MP_Is_remote( id ) ) {
-    return NULL;
-  }
-
-  return _RTEMS_tasks_MP_Get_packet();
-}
-
-/*
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/mpci.h>
+#include <rtems/mppkt.h>
+#include <rtems/object.h>
+#include <rtems/options.h>
+#include <rtems/tasks.h>
+#include <rtems/thread.h>
+#include <rtems/watchdog.h>
+
+/*PAGE
+ *
  *  _RTEMS_tasks_MP_Send_process_packet
  *
@@ -88,5 +32,5 @@
   RTEMS_tasks_MP_Remote_operations operation,
   Objects_Id                       task_id,
-  rtems_name                       name
+  Objects_Name                     name
 )
 {
@@ -99,5 +43,5 @@
 
       the_packet                    = _RTEMS_tasks_MP_Get_packet();
-      the_packet->Prefix.the_class  = MP_PACKET_TASKS;
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_TASKS;
       the_packet->Prefix.length     = sizeof ( RTEMS_tasks_MP_Packet );
       the_packet->Prefix.to_convert = sizeof ( RTEMS_tasks_MP_Packet );
@@ -115,90 +59,77 @@
     case RTEMS_TASKS_MP_SET_PRIORITY_REQUEST:
     case RTEMS_TASKS_MP_SET_PRIORITY_RESPONSE:
+    case RTEMS_TASKS_MP_GET_NOTE_REQUEST:
+    case RTEMS_TASKS_MP_GET_NOTE_RESPONSE:
+    case RTEMS_TASKS_MP_SET_NOTE_REQUEST:
+    case RTEMS_TASKS_MP_SET_NOTE_RESPONSE:
       break;
   }
 }
 
-static rtems_status_code _RTEMS_tasks_MP_Send_request_packet(
-  RTEMS_tasks_MP_Packet            *the_packet,
-  Objects_Id                        id,
-  RTEMS_tasks_MP_Remote_operations  operation
+/*PAGE
+ *
+ *  _RTEMS_tasks_MP_Send_request_packet
+ *
+ */
+
+rtems_status_code _RTEMS_tasks_MP_Send_request_packet (
+  RTEMS_tasks_MP_Remote_operations operation,
+  Objects_Id                       task_id,
+  rtems_task_priority                 new_priority,
+  unsigned32                       notepad,
+  unsigned32                       note
 )
 {
-  Status_Control status;
-
-  the_packet->Prefix.the_class  = MP_PACKET_TASKS;
-  the_packet->Prefix.length     = sizeof( *the_packet );
-  the_packet->Prefix.to_convert = sizeof( *the_packet );
-  the_packet->Prefix.id         = id;
-  the_packet->operation         = operation;
-
-  status = _MPCI_Send_request_packet(
-    _Objects_Get_node( id ),
-    &the_packet->Prefix,
-    STATES_READY /* Not used */
-  );
-  return _Status_Get( status );
-}
-
-rtems_status_code _RTEMS_tasks_MP_Set_priority(
-  rtems_id             id,
-  rtems_task_priority  new_priority,
-  rtems_task_priority *old_priority
-)
-{
   RTEMS_tasks_MP_Packet *the_packet;
 
-  the_packet = _RTEMS_tasks_MP_Get_request_packet( id );
-  if ( the_packet == NULL ) {
-    return RTEMS_INVALID_ID;
+  switch ( operation ) {
+
+    case RTEMS_TASKS_MP_SUSPEND_REQUEST:
+    case RTEMS_TASKS_MP_RESUME_REQUEST:
+    case RTEMS_TASKS_MP_SET_PRIORITY_REQUEST:
+    case RTEMS_TASKS_MP_GET_NOTE_REQUEST:
+    case RTEMS_TASKS_MP_SET_NOTE_REQUEST:
+
+      the_packet                    = _RTEMS_tasks_MP_Get_packet();
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_TASKS;
+      the_packet->Prefix.length     = sizeof ( RTEMS_tasks_MP_Packet );
+      the_packet->Prefix.to_convert = sizeof ( RTEMS_tasks_MP_Packet );
+      the_packet->operation         = operation;
+      the_packet->Prefix.id         = task_id;
+      the_packet->the_priority      = new_priority;
+      the_packet->notepad           = notepad;
+      the_packet->note              = note;
+
+      return _MPCI_Send_request_packet(
+        rtems_get_node( task_id ),
+        &the_packet->Prefix,
+        STATES_READY     /* Not used */
+      );
+      break;
+
+    case RTEMS_TASKS_MP_ANNOUNCE_CREATE:
+    case RTEMS_TASKS_MP_ANNOUNCE_DELETE:
+    case RTEMS_TASKS_MP_SUSPEND_RESPONSE:
+    case RTEMS_TASKS_MP_RESUME_RESPONSE:
+    case RTEMS_TASKS_MP_SET_PRIORITY_RESPONSE:
+    case RTEMS_TASKS_MP_GET_NOTE_RESPONSE:
+    case RTEMS_TASKS_MP_SET_NOTE_RESPONSE:
+      break;
+
   }
-
-  the_packet->the_priority = new_priority;
-  _Thread_Executing->Wait.return_argument = old_priority;
-  return _RTEMS_tasks_MP_Send_request_packet(
-    the_packet,
-    id,
-    RTEMS_TASKS_MP_SET_PRIORITY_REQUEST
-  );
-}
-
-rtems_status_code _RTEMS_tasks_MP_Suspend( rtems_id id )
-{
-  RTEMS_tasks_MP_Packet *the_packet;
-
-  the_packet = _RTEMS_tasks_MP_Get_request_packet( id );
-  if ( the_packet == NULL ) {
-    return RTEMS_INVALID_ID;
-  }
-
-  return _RTEMS_tasks_MP_Send_request_packet(
-    the_packet,
-    id,
-    RTEMS_TASKS_MP_SUSPEND_REQUEST
-  );
-}
-
-rtems_status_code _RTEMS_tasks_MP_Resume( rtems_id id )
-{
-  RTEMS_tasks_MP_Packet *the_packet;
-
-  the_packet = _RTEMS_tasks_MP_Get_request_packet( id );
-  if ( the_packet == NULL ) {
-    return RTEMS_INVALID_ID;
-  }
-
-  return _RTEMS_tasks_MP_Send_request_packet(
-    the_packet,
-    id,
-    RTEMS_TASKS_MP_RESUME_REQUEST
-  );
-}
-
-/*
+  /*
+   *  The following line is included to satisfy compilers which
+   *  produce warnings when a function does not end with a return.
+   */
+  return RTEMS_SUCCESSFUL;
+}
+
+/*PAGE
+ *
  *  _RTEMS_tasks_MP_Send_response_packet
  *
  */
 
-static void _RTEMS_tasks_MP_Send_response_packet (
+void _RTEMS_tasks_MP_Send_response_packet (
   RTEMS_tasks_MP_Remote_operations  operation,
   Thread_Control                   *the_thread
@@ -212,4 +143,6 @@
     case RTEMS_TASKS_MP_RESUME_RESPONSE:
     case RTEMS_TASKS_MP_SET_PRIORITY_RESPONSE:
+    case RTEMS_TASKS_MP_GET_NOTE_RESPONSE:
+    case RTEMS_TASKS_MP_SET_NOTE_RESPONSE:
 
       the_packet = (RTEMS_tasks_MP_Packet *) the_thread->receive_packet;
@@ -223,5 +156,5 @@
 
       _MPCI_Send_response_packet(
-        _Objects_Get_node( the_packet->Prefix.source_tid ),
+        rtems_get_node( the_packet->Prefix.source_tid ),
         &the_packet->Prefix
       );
@@ -233,4 +166,6 @@
     case RTEMS_TASKS_MP_RESUME_REQUEST:
     case RTEMS_TASKS_MP_SET_PRIORITY_REQUEST:
+    case RTEMS_TASKS_MP_GET_NOTE_REQUEST:
+    case RTEMS_TASKS_MP_SET_NOTE_REQUEST:
       break;
 
@@ -238,5 +173,6 @@
 }
 
-/*
+/*PAGE
+ *
  *
  *  _RTEMS_tasks_MP_Process_packet
@@ -244,5 +180,5 @@
  */
 
-static void _RTEMS_tasks_MP_Process_packet (
+void _RTEMS_tasks_MP_Process_packet (
   rtems_packet_prefix  *the_packet_prefix
 )
@@ -250,4 +186,5 @@
   RTEMS_tasks_MP_Packet *the_packet;
   Thread_Control   *the_thread;
+  boolean           ignored;
 
   the_packet = (RTEMS_tasks_MP_Packet *) the_packet_prefix;
@@ -257,10 +194,10 @@
     case RTEMS_TASKS_MP_ANNOUNCE_CREATE:
 
-      _Objects_MP_Allocate_and_open(
-        &_RTEMS_tasks_Information.Objects,
-        the_packet->name,
-        the_packet->Prefix.id,
-        true
-      );
+      ignored = _Objects_MP_Open(
+                  &_Thread_Information,
+                  the_packet->name,
+                  the_packet->Prefix.id,
+                  TRUE
+                );
 
       _MPCI_Return_packet( the_packet_prefix );
@@ -269,8 +206,5 @@
     case RTEMS_TASKS_MP_ANNOUNCE_DELETE:
 
-      _Objects_MP_Close(
-        &_RTEMS_tasks_Information.Objects,
-        the_packet->Prefix.id
-      );
+      _Objects_MP_Close( &_Thread_Information, the_packet->Prefix.id );
 
       _MPCI_Return_packet( the_packet_prefix );
@@ -291,4 +225,5 @@
     case RTEMS_TASKS_MP_SUSPEND_RESPONSE:
     case RTEMS_TASKS_MP_RESUME_RESPONSE:
+    case RTEMS_TASKS_MP_SET_NOTE_RESPONSE:
 
       the_thread = _MPCI_Process_response( the_packet_prefix );
@@ -332,18 +267,72 @@
       _MPCI_Return_packet( the_packet_prefix );
       break;
+
+    case RTEMS_TASKS_MP_GET_NOTE_REQUEST:
+
+      the_packet->Prefix.return_code = rtems_task_get_note(
+        the_packet->Prefix.id,
+        the_packet->notepad,
+        &the_packet->note
+      );
+
+      _RTEMS_tasks_MP_Send_response_packet(
+        RTEMS_TASKS_MP_GET_NOTE_RESPONSE,
+        _Thread_Executing
+      );
+      break;
+
+    case RTEMS_TASKS_MP_GET_NOTE_RESPONSE:
+
+      the_thread = _MPCI_Process_response( the_packet_prefix );
+
+      *(unsigned32 *)the_thread->Wait.return_argument = the_packet->note;
+
+      _MPCI_Return_packet( the_packet_prefix );
+      break;
+
+    case RTEMS_TASKS_MP_SET_NOTE_REQUEST:
+
+      the_packet->Prefix.return_code = rtems_task_set_note(
+        the_packet->Prefix.id,
+        the_packet->notepad,
+        the_packet->note
+      );
+
+      _RTEMS_tasks_MP_Send_response_packet(
+        RTEMS_TASKS_MP_SET_NOTE_RESPONSE,
+        _Thread_Executing
+      );
+      break;
   }
 }
 
-static void _RTEMS_tasks_MP_Initialize( void )
-{
-  _MPCI_Register_packet_processor(
-    MP_PACKET_TASKS,
-    _RTEMS_tasks_MP_Process_packet
-  );
-}
-
-RTEMS_SYSINIT_ITEM(
-  _RTEMS_tasks_MP_Initialize,
-  RTEMS_SYSINIT_CLASSIC_TASKS_MP,
-  RTEMS_SYSINIT_ORDER_MIDDLE
-);
+/*PAGE
+ *
+ *  _RTEMS_tasks_MP_Send_object_was_deleted
+ *
+ *  This routine is not neededby the Tasks since a task
+ *  cannot be globally deleted.
+ *
+ */
+
+/*PAGE
+ *
+ *  _RTEMS_tasks_MP_Send_extract_proxy
+ *
+ *  This routine is not neededby the Tasks since a task
+ *  cannot be globally deleted.
+ *
+ */
+
+/*PAGE
+ *
+ *  _RTEMS_tasks_MP_Get_packet
+ *
+ */
+
+RTEMS_tasks_MP_Packet *_RTEMS_tasks_MP_Get_packet ( void )
+{
+  return ( (RTEMS_tasks_MP_Packet *) _MPCI_Get_packet() );
+}
+
+/* end of file */
